Package org.apache.cayenne.query

## Class EJBQLQuery

- java.lang.Object
- - org.apache.cayenne.query.CacheableQuery
  - - org.apache.cayenne.query.EJBQLQuery

- All Implemented Interfaces:
    `Serializable`, `Query`

      public class EJBQLQuery
      extends CacheableQuery

  An EJBQL query representation in Cayenne.
  Since:
    3.0
  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected String` | `ejbqlStatement` |
    `protected EJBQLCompiledExpression` | `expression` |
    `protected Map<String,​Object>` | `namedParameters` |
    `protected Map<Integer,​Object>` | `positionalParameters` |

    - ### Fields inherited from class org.apache.cayenne.query.CacheableQuery

      `logger`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `EJBQLQuery()` |
    `EJBQLQuery​(String ejbqlStatement)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `SQLAction` | `createSQLAction​(SQLActionVisitor visitor)` | A callback method invoked by Cayenne during the final execution phase of the query run.
    `protected org.apache.cayenne.query.BaseQueryMetadata` | `getBaseMetaData()` |
    `String` | `getEjbqlStatement()` | Returns an unparsed EJB QL statement used to initialize this query.
    `EJBQLCompiledExpression` | `getExpression​(EntityResolver resolver)` | Returns lazily initialized EJBQLCompiledExpression for this query EJBQL.
    `int` | `getFetchLimit()` | Returns the fetchLimit property indicating the maximum number of rows this query would return.
    `int` | `getFetchOffset()` |
    `QueryMetadata` | `getMetaData​(EntityResolver resolver)` | Returns query runtime parameters.
    `Map<String,​Object>` | `getNamedParameters()` | Returns unmodifiable map of combined named and positional parameters.
    `int` | `getPageSize()` |
    `Map<Integer,​Object>` | `getPositionalParameters()` |
    `int` | `getQueryTimeout()` |
    `int` | `getStatementFetchSize()` |
    `void` | `initWithProperties​(Map<String,​?> properties)` |
    `boolean` | `isFetchingDataRows()` |
    `void` | `route​(QueryRouter router, EntityResolver resolver, Query substitutedQuery)` | A callback method invoked by Cayenne during the routing phase of the query execution.
    `void` | `setEjbqlStatement​(String text)` |
    `void` | `setFetchingDataRows​(boolean flag)` |
    `void` | `setFetchLimit​(int fetchLimit)` | Sets the fetchLimit property indicating the maximum number of rows this query would return.
    `void` | `setFetchOffset​(int fetchOffset)` |
    `void` | `setPageSize​(int pageSize)` |
    `void` | `setParameter​(int position, Object object)` | Sets a positional query parameter value.
    `void` | `setParameter​(String name, Object object)` | Sets a named query parameter value.
    `void` | `setQueryTimeout​(int queryTimeout)` | Sets query timeout.
    `void` | `setStatementFetchSize​(int size)` | Sets statement's fetch size (0 for no default size)

    - ### Methods inherited from class org.apache.cayenne.query.CacheableQuery

      `getCacheGroup, getCacheStrategy, setCacheGroup, setCacheStrategy, useLocalCache, useLocalCache, useSharedCache, useSharedCache`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### ejbqlStatement

          protected String ejbqlStatement

    - #### namedParameters

          protected Map<String,​Object> namedParameters

    - #### positionalParameters

          protected Map<Integer,​Object> positionalParameters

    - #### expression

          protected transient EJBQLCompiledExpression expression

  - ### Constructor Detail

    - #### EJBQLQuery

          public EJBQLQuery​(String ejbqlStatement)

    - #### EJBQLQuery

          public EJBQLQuery()

  - ### Method Detail

    - #### initWithProperties

          public void initWithProperties​(Map<String,​?> properties)

    - #### getMetaData

          public QueryMetadata getMetaData​(EntityResolver resolver)

      Description copied from interface: `Query`
      Returns query runtime parameters. The method is called at various stages of the execution by Cayenne access stack to retrieve query parameters. EntityResolver instance is passed to this method, meaning that the query doesn't need to store direct references to Cayenne mapping objects and can resolve them at runtime.

    - #### isFetchingDataRows

          public boolean isFetchingDataRows()

    - #### setFetchingDataRows

          public void setFetchingDataRows​(boolean flag)

    - #### getBaseMetaData

          protected org.apache.cayenne.query.BaseQueryMetadata getBaseMetaData()

      Specified by:
        `getBaseMetaData` in class `CacheableQuery`

    - #### route

          public void route​(QueryRouter router,
                            EntityResolver resolver,
                            Query substitutedQuery)

      Description copied from interface: `Query`
      A callback method invoked by Cayenne during the routing phase of the query execution. Mapping of DataNodes is provided by QueryRouter. Query should use a `QueryRouter.route(QueryEngine, Query, Query)` callback method to route itself. Query can create one or more substitute queries or even provide its own QueryEngine to execute itself.

    - #### createSQLAction

          public SQLAction createSQLAction​(SQLActionVisitor visitor)

      Description copied from interface: `Query`
      A callback method invoked by Cayenne during the final execution phase of the query run. A concrete query implementation is given a chance to decide how it should be handled. Implementors can pick an appropriate method of the SQLActionVisitor to handle itself, create a custom SQLAction of its own, or substitute itself with another query that should be used for SQLAction construction.

    - #### getEjbqlStatement

          public String getEjbqlStatement()

      Returns an unparsed EJB QL statement used to initialize this query.

    - #### getExpression

          public EJBQLCompiledExpression getExpression​(EntityResolver resolver)
                                                throws EJBQLException

      Returns lazily initialized EJBQLCompiledExpression for this query EJBQL.
      Throws:
        `EJBQLException`

    - #### getNamedParameters

          public Map<String,​Object> getNamedParameters()

      Returns unmodifiable map of combined named and positional parameters. Positional parameter keys are Integers, while named parameter keys are strings.

    - #### getPositionalParameters

          public Map<Integer,​Object> getPositionalParameters()

    - #### setParameter

          public void setParameter​(String name,
                                   Object object)

      Sets a named query parameter value.

    - #### setParameter

          public void setParameter​(int position,
                                   Object object)

      Sets a positional query parameter value. Note that parameter indexes are starting from 1.

    - #### getFetchLimit

          public int getFetchLimit()

      Returns the fetchLimit property indicating the maximum number of rows this query would return.

    - #### setFetchLimit

          public void setFetchLimit​(int fetchLimit)

      Sets the fetchLimit property indicating the maximum number of rows this query would return.

    - #### getFetchOffset

          public int getFetchOffset()

    - #### setFetchOffset

          public void setFetchOffset​(int fetchOffset)

    - #### setEjbqlStatement

          public void setEjbqlStatement​(String text)

    - #### getPageSize

          public int getPageSize()

    - #### setPageSize

          public void setPageSize​(int pageSize)

    - #### setStatementFetchSize

          public void setStatementFetchSize​(int size)

      Sets statement's fetch size (0 for no default size)
      Since:
        3.0

    - #### getStatementFetchSize

          public int getStatementFetchSize()

      Returns:
        statement's fetch size
      Since:
        3.0

    - #### setQueryTimeout

          public void setQueryTimeout​(int queryTimeout)

      Sets query timeout.
      Since:
        4.2

    - #### getQueryTimeout

          public int getQueryTimeout()

      Returns:
        query timeout
      Since:
        4.2